import { ExceptionFilter, ArgumentsHost } from '@nestjs/common';
import { AbstractHttpAdapter, HttpAdapterHost } from '@nestjs/core';
import { CustomExceptionReponse } from '../interface/custom-exception-response.interface';
export declare abstract class AbstractExceptionFilter<ExceptionType> implements ExceptionFilter {
    protected httpAdapter: AbstractHttpAdapter;
    constructor(adapterHost: HttpAdapterHost);
    getResponse(host: ArgumentsHost, _exception: ExceptionType): Record<string, unknown>;
    catch(exception: ExceptionType, host: ArgumentsHost): void;
    abstract makeCustomResponse(exception: ExceptionType): CustomExceptionReponse;
}
