"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ErrorExceptionFilter = void 0;
const common_1 = require("@nestjs/common");
const abstract_exception_filter_1 = require("./abstract-exception.filter");
const custom_error_exception_1 = require("../exception/custom-error.exception");
let ErrorExceptionFilter = class ErrorExceptionFilter extends abstract_exception_filter_1.AbstractExceptionFilter {
    makeCustomResponse(exception) {
        return {
            status: this.getStatus(exception),
            message: exception.message,
            type: exception.name,
            errorCode: this.getErrCode(exception)
        };
    }
    getStatus(exception) {
        let status = common_1.HttpStatus.INTERNAL_SERVER_ERROR;
        if (exception instanceof common_1.HttpException)
            status = exception.getStatus();
        return status;
    }
    getErrCode(exception) {
        let errCode = -1;
        if (exception instanceof common_1.HttpException)
            errCode = exception.getStatus();
        if (exception instanceof custom_error_exception_1.CustomErrorException)
            errCode = exception.errCode;
        return errCode;
    }
};
ErrorExceptionFilter = __decorate([
    (0, common_1.Catch)()
], ErrorExceptionFilter);
exports.ErrorExceptionFilter = ErrorExceptionFilter;
