import { Logger } from '@nestjs/common';
import { HydratedDocument, Model, ObjectId } from 'mongoose';
declare type MongooseDocument = HydratedDocument<any>;
export declare type MongooseDocumentID = string | ObjectId;
export declare abstract class MongooseRepository<Collection, MongooseModel> {
    protected model: Model<MongooseModel>;
    protected readonly logger: Logger;
    constructor(model: Model<MongooseModel>);
    insertOne(item: Collection, name: string): Promise<ObjectId>;
    create(document: Collection): Promise<MongooseDocument>;
    groupBy(group: any, match?: {}, select?: {}): Promise<any[]>;
    aggregate(group: any, match?: {}, select?: {}, unwind?: string): Promise<any[]>;
    aggregateNotExists(from: string, joinFrom: string, joinLet: string, match?: any): Promise<any[]>;
    findAll(select?: object): Promise<any[]>;
    findById(id: MongooseDocumentID, select?: object): Promise<MongooseDocument>;
    updateOneById(id: MongooseDocumentID, data: any): Promise<void>;
    updateOne(query: any, data: any, pushData?: {}, strict?: boolean): Promise<void>;
    deleteOneById(id: string | number): Promise<void>;
    find(searchParams: any, select?: any, sort?: any, regex?: boolean): Promise<any[]>;
}
export {};
